export declare const bareImportRE: RegExp;
export declare const deepImportRE: RegExp;
export declare function resolveFrom(id: string, basedir: string): string;
interface DebuggerOptions {
    onlyWhenFocused?: boolean | string;
}
export declare function createDebugger(ns: string, options?: DebuggerOptions): (msg: string, ...args: any[]) => void;
export declare function normalizePath(id: string): string;
export declare function fsPathFromId(id: string): string;
export declare const queryRE: RegExp;
export declare const hashRE: RegExp;
export declare const cleanUrl: (url: string) => string;
export declare const isExternalUrl: (url: string) => boolean;
export declare const isDataUrl: (url: string) => boolean;
export declare const isJSRequest: (url: string) => boolean;
export declare const isImportRequest: (url: string) => boolean;
export declare function removeImportQuery(url: string): string;
export declare function injectQuery(url: string, queryToInject: string): string;
export declare function removeTimestampQuery(url: string): string;
export declare function asyncReplace(input: string, re: RegExp, replacer: (match: RegExpExecArray) => string | Promise<string>): Promise<string>;
export declare function timeFrom(start: number, subtract?: number): string;
/**
 * pretty url for logging.
 */
export declare function prettifyUrl(url: string, root: string): string;
export declare function isObject(value: unknown): value is Record<string, any>;
export declare function lookupFile(dir: string, formats: string[], pathOnly?: boolean): string | undefined;
export declare function pad(source: string, n?: number): string;
export declare function posToNumber(source: string, pos: number | {
    line: number;
    column: number;
}): number;
export declare function numberToPos(source: string, offset: number | {
    line: number;
    column: number;
}): {
    line: number;
    column: number;
};
export declare function generateCodeFrame(source: string, start?: number | {
    line: number;
    column: number;
}, end?: number): string;
export declare function writeFile(filename: string, content: string | Uint8Array): void;
export declare function emptyDir(dir: string): void;
export declare function crawlDir(root: string, onFile: (file: string, name: string, parent: string) => void): void;
export {};
